net.sf.saxon.trace

## Class TimingTraceListener

- java.lang.Object
- - net.sf.saxon.trace.TimingTraceListener

- All Implemented Interfaces:
    EventListener, TraceListener

      public class TimingTraceListener
      extends Object
      implements TraceListener

  A trace listener that records timing information for templates and functions, outputting this information as an HTML report to a specified destination when the transformation completes.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TimingTraceListener()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `close()` Called at end.
    `void` | `endCurrentItem(Item item)` Called after a node of the source tree got processed
    `void` | `enter(InstructionInfo instruction, XPathContext context)` Called when an instruction in the stylesheet gets processed
    `PreparedStylesheet` | `getStyleSheet()` Prepare Stylesheet to render the analyzed XML data out.
    `void` | `leave(InstructionInfo instruction)` Called after an instruction of the stylesheet got processed
    `void` | `open(Controller controller)` Called at start
    `void` | `setOutputDestination(PrintStream stream)` Set the PrintStream to which the output will be written.
    `void` | `startCurrentItem(Item item)` Called when an item becomes current

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TimingTraceListener

          public TimingTraceListener()

  - ### Method Detail

    - #### setOutputDestination

          public void setOutputDestination(PrintStream stream)

      Set the PrintStream to which the output will be written.
      Specified by:
        `setOutputDestination` in interface `TraceListener`
      Parameters:
        `stream` - the PrintStream to be used for output. By default, the output is written to System.err.
      Throws:
        `XPathException`
        `XMLStreamException`

    - #### open

          public void open(Controller controller)

      Called at start
      Specified by:
        `open` in interface `TraceListener`
      Parameters:
        `controller` - identifies the transformation controller, and provides the listener with access to context and configuration information

    - #### close

          public void close()

      Called at end. This method builds the XML out and analyzed html output
      Specified by:
        `close` in interface `TraceListener`

    - #### enter

          public void enter(InstructionInfo instruction,
                   XPathContext context)

      Called when an instruction in the stylesheet gets processed
      Specified by:
        `enter` in interface `TraceListener`
      Parameters:
        `instruction` - gives information about the instruction being executed, and about the context in which it is executed. This object is mutable, so if information from the InstructionInfo is to be retained, it must be copied.

    - #### leave

          public void leave(InstructionInfo instruction)

      Called after an instruction of the stylesheet got processed
      Specified by:
        `leave` in interface `TraceListener`
      Parameters:
        `instruction` - gives the same information that was supplied to the enter method, though it is not necessarily the same object. Note that the line number of the instruction is that of the start tag in the source stylesheet, not the line number of the end tag.

    - #### startCurrentItem

          public void startCurrentItem(Item item)

      Called when an item becomes current
      Specified by:
        `startCurrentItem` in interface `TraceListener`
      Parameters:
        `item` - the new current item. Item objects are not mutable; it is safe to retain a reference to the Item for later use.

    - #### endCurrentItem

          public void endCurrentItem(Item item)

      Called after a node of the source tree got processed
      Specified by:
        `endCurrentItem` in interface `TraceListener`
      Parameters:
        `item` - the item that was current, whose processing is now complete. This will represent the same underlying item as the corresponding startCurrentItem() call, though it will not necessarily be the same actual object.

    - #### getStyleSheet

          public PreparedStylesheet getStyleSheet()
                                           throws TransformerConfigurationException

      Prepare Stylesheet to render the analyzed XML data out. This method can be overridden in a subclass to produce the output in a different format.
      Throws:
        `TransformerConfigurationException`

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.